package jedi

import (
	"golib.gaore.com/GaoreGo/gaore-common-sdk-go/sdk/requests"
	"golib.gaore.com/GaoreGo/gaore-common-sdk-go/sdk/responses"
)

type SendSmsRequest struct {
	*requests.RpcRequest
	User     string `position:"Query" field:"user" default:"" `
	Code     string `position:"Query" field:"code" default:"" `
	Params   string `position:"Query" field:"params" default:"" `
	TestBody string `position:"Body" field:"test_body" default:"2121" `
}

type SendSmsResponseData struct {
	Account string `json:"account"`
	Total   int    `json:"total"`
}

type SendSmsResponse struct {
	*responses.BaseResponse
	Data SendSmsResponseData `json:"data"`
}

func CreateSendSmsRequest() (req *SendSmsRequest) {
	req = &SendSmsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	req.InitWithApiInfo(HOST, VERSION, "/api/sms/send")
	req.Method = requests.GET
	return
}

func CreateSendSmsResponse() (response *SendSmsResponse) {
	response = &SendSmsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
